package com.cool.hot100.binary_search;

import org.junit.Test;

import java.util.Arrays;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/09/13/16:02
 * DayNumber 4
 * Hard 2
 * Level ?
 */
public class Num34 {
    public int[] searchRange(int[] nums, int target) {
        int index = binarySearch(nums, target);
        if(index==nums.length||nums[index]!=target){
            return new int[]{-1,-1};
        }
        int end=binarySearch(nums,target+1)-1;
        return new int[]{index,end};
    }

    private int binarySearch(int[] nums, int target) {
        int left=0;
        int right=nums.length-1;
        while (left <= right) {
            int mid =left+(right-left)/2;
            if(target>nums[mid]){
                left=mid+1;
            }else{
                right=mid-1;
            }
        }
        return left;
    }

    @Test
    public void test() {
        searchRange(new int[]{5,7,7,8,8,10}, 6);
    }
}
